;REALMS OF INTERACTION
;part 5 of 5
;by Alan Davis
;from ZX Computing, September 1986
;
;NOTE: I've included the correction from page 7 of the same issue. JimG.
;
       20                  ORG  65000
FDE8   30 AF               XOR  A
FDE9   40 32C4FE           LD   (EXIT),A
FDEC   50 2141FD           LD   HL,FKLC+2
FDEF   60 0605             LD   B,#05
FDF1   70 CDB2FE    LOOP   CALL RND
FDF4   80 3A765C           LD   A,(SEED)
FDF7   90 E603             AND  #03
FDF9  100 FE00             CP   #00
FDFB  110 CC15FE           CALL Z,MOVE
FDFE  120 3AC4FE           LD   A,(EXIT)
FE01  130 FE00             CP   #00
FE03  140 C20EFE           JP   NZ,QUIT
FE06  150 23               INC  HL
FE07  160 23               INC  HL
FE08  170 10E7             DJNZ LOOP
FE0A  180 010000           LD   BC,#0000
FE0D  190 C9               RET
FE0E  200 3E07      QUIT   LD   A,#07
FE10  210 90               SUB  B
FE11  220 4F               LD   C,A
FE12  230 0600             LD   B,#00
FE14  240 C9               RET
FE15  250 CDB2FE    MOVE   CALL RND
FE18  260 3A765C           LD   A,(SEED)
FE1B  270 E603             AND  #03
FE1D  280 C601             ADD  A,#01
FE1F  290 32C5FE           LD   (DIR),A
FE22  300 FE01             CP   #01
FE24  310 CC37FE           CALL Z,NORTH
FE27  320 FE02             CP   #02
FE29  330 CC45FE           CALL Z,SOUTH
FE2C  340 FE03             CP   #03
FE2E  350 CC53FE           CALL Z,EAST
FE31  360 FE04             CP   #04
FE33  370 CC65FE           CALL Z,WEST
FE36  380 C9               RET
FE37  390 7E        NORTH  LD   A,(HL)
FE38  400 FE01             CP   #01
FE3A  410 CA77FE           JP   Z,END
FE3D  420 CD79FE           CALL TEST_D
FE40  430 3D               DEC  A
FE41  440 77               LD   (HL),A
FE42  450 C396FE           JP   TEST_A
FE45  460 7E        SOUTH  LD   A,(HL)
FE46  470 FE05             CP   #05
FE48  480 CA77FE           JP   Z,END
FE4B  490 CD79FE           CALL TEST_D
FE4E  500 3C               INC  A
FE4F  510 77               LD   (HL),A
FE50  520 C396FE           JP   TEST_A
FE53  530 23        EAST   INC  HL
FE54  540 7E               LD   A,(HL)
FE55  550 FE05             CP   #05
FE57  570 2B               DEC  HL
FE58  560 CA77FE           JP   Z,END
FE5B  580 CD79FE           CALL TEST_D
FE5E  590 23               INC  HL
FE5F  600 3C               INC  A
FE60  610 77               LD   (HL),A
FE61  620 2B               DEC  HL
FE62  630 C396FE           JP   TEST_A
FE65  640 23        WEST   INC  HL
FE66  650 7E               LD   A,(HL)
FE67  660 FE01             CP   #01
FE69  680 2B               DEC  HL
FE6A  670 CA77FE           JP   Z,END
FE6D  690 CD79FE           CALL TEST_D
FE70  700 23               INC  HL
FE71  710 3D               DEC  A
FE72  720 77               LD   (HL),A
FE73  730 2B               DEC  HL
FE74  740 C396FE           JP   TEST_A
FE77  750 AF        END    XOR  A
FE78  760 C9               RET
FE79  770 F5        TEST_D PUSH AF
FE7A  780 3A3FFD           LD   A,(FKLC)
FE7D  790 BE               CP   (HL)
FE7E  800 CA83FE           JP   Z,TESTD2
FE81  810 F1               POP  AF
FE82  820 C9               RET
FE83  830 23        TESTDE INC  HL
FE84  840 3A40FD           LD   A,(FKLC+1)
FE87  850 BE               CP   (HL)
FE88  860 2B               DEC  HL
FE89  870 CA8EFE           JP   Z,DEP
FE8C  880 F1               POP  AF
FE8D  890 C9               RET
FE8E  900 3AC5FE    DEP    LD   A,(DIR)
FE91  910 32C4FE           LD   (EXIT),A
FE94  920 F1               POP  AF
FE95  930 C9               RET
FE96  940 3A3FFD    TEST_A LD   A,(FKLC)
FE99  950 BE               CP   (HL)
FE9A  960 CAA0FE           JP   Z,TESTA2
FE9D  970 C377FE           JP   END
FEA0  980 23        TESTA2 INC  HL
FEA1  990 3A40FD           LD   A,(FKLC+1)
FEA4 1000 BE               CP   (HL)
FEA5 1010 2B               DEC  HL
FEA6 1020 CAACFE           JP   Z,ARR
FEA9 1030 C377FE           JP   END
FEAC 1040 3E05      ARR    LD   A,#05
FEAE 1050 32C4FE           LD   (EXIT),A
FEB1 1060 C9               RET
FEB2 1070 C5        RND    PUSH BC
FEB3 1080 E5               PUSH HL
FEB4 1090 3EA5             LD   A,#A5
FEB6 1100 CD282D           CALL #2D28
FEB9 1110 EF               RST  #28
FEBA 1120 2F               DEFB 47
FEBB 1130 38               DEFB 56
FEBC 1140 061D             LD   B,#1D
FEBE 1150 EF               RST  #28
FEBF 1160 3B               DEFB 59
FEC0 1170 38               DEFB 56
FEC1 1180 E1               POP  HL
FEC2 1190 C1               POP  BC
FEC3 1200 C9               RET
FEC4 1210 00        EXIT   DEFB 0
FEC5 1220 00        DIR    DEFB 0
     1230           FKLC   EQU  64831
     1240           SEED   EQU  23670
